procedure setlodkeywd (infile,comments,change_level,opus_flag,pedigree)

file	infile 		{prompt="File or list of lod files to fix"}
bool	comments	{yes,prompt="Add comments? (yes/no)"}
string	change_level	{"SEVERE",prompt="Change level value"}
string	opus_flag	{"Y",prompt="Opus flag (Y/N)"}
string	pedigree	{"",prompt="Pedigree entry"}


struct	*inlist
struct	*inlod

begin

	file	inputlst, lodfile, outlodfile, histfile, descfile, rootname
	int	pos, found, nbsp, bsp1
	string	keyword, ch_lev, o_flag, ped
	int	endheader


        # Expand input file list into a temporary file.
 
        inputlst = mktemp("tmp$input")
        sections (infile,option="fullname",>inputlst)
	inlist = inputlst

	ch_lev = change_level
	o_flag = opus_flag
	ped = pedigree

	# Reads 1 lod file name from input list.	

	while (fscan(inlist,lodfile) != EOF)  {
	       inlod = lodfile
	       endheader = 0

	       rootname = substr(lodfile,1,strlen(lodfile)-4)

	       outlodfile = mktemp("tmp$lod")

	       # Reads 1 line at a time from lod file, and copies it to
	       # a temp lod file, adding the history lines from correspondent
	       # fits file to the COMMENT entry at the lod 'header'.

	       while (fscan(inlod,line) != EOF)  {

		      pos = stridx(" ",line)
                      keyword = substr(line,1,pos-1)

		      if ( (keyword == "CHANGE_LEVEL")  && (ch_lev != "") )
			   printf ("CHANGE_LEVEL = %s\n",ch_lev, >> outlodfile)

		      else if ( (keyword == "OPUS_FLAG")  && (o_flag != "") )
			        printf ("OPUS_FLAG = %s\n",
					 o_flag, >> outlodfile)

		      else if ( (keyword == "PEDIGREE")  && (ped != "") )
			    printf ("PEDIGREE = %s\n", ped, >> outlodfile)

		      else if ( (keyword == "COMMENT") && (endheader == 0))  {
				if ( comments )  {
			             printf ("COMMENT = ", >> outlodfile)
			   	     hedit (rootname//".fits[0]", "DESCRIP", ".", up-) | scan (s1,s2,line)
                                    #hedit (rootname//".r?h", "DESCRIP", ".", up-) | scan (s1,s2,line)
		           	     printf ("%s\n", line, >> outlodfile)
			   	     histfile = mktemp("tmp$hist")
			   	     catfits (rootname//".fits[0]",long+) | match ("HISTORY",  > histfile )
                                    #imhead (rootname//".r?h", l+) | match ("HISTORY", > histfile )
			   	     list = histfile
                                     printf("%s \n",line)
			   	     while (fscan(list,line) != EOF)  {
					    line = substr(line,9,strlen(line))
                                            printf("COMMENT = %s | \n", line)
                                           #fflush(stdout)
					    found = 1
                                            nbsp = 3
					    for (i=1; i<=70; i+=1) {
					      if (substr(line,i,i) == " "){
						  found = found*1
                                                  nbsp = i
					      }else
						  found = found*0
					    }
#printf("found = %d and nbsp = %d line = %s  \n", found,nbsp,line)
#for (i=1; i<=nbsp; i+=1) printf(" line = %s \n",substr(line,i,i))

					    for (i=1; i<=nbsp; i+=1) {
					      if (substr(line,i,i) != " "){
						  bsp1 = i
 						  nbsp = i
          				      }
        				    }
					    if ( found == 0 )
				               printf ("%s\n",substr(line,bsp1,strlen(line)), >> outlodfile)
			             }
			             delete (histfile) 
		      	             endheader = 1
		                }
			        else 
				      printf ("%s\n", line, >> outlodfile)
			   }

		      else  
			    printf ("%s\n", line, >> outlodfile)
		      flpr ; flpr ; flpr

	       }

	       delete (lodfile)
	       rename (outlodfile, rootname//".lod")
	       flpr
	}

	delete (inputlst)
	flpr ; flpr

end

			   

